
void calc_minus_mean ( int x[], double x_minus_mean[], double *sum_x_minus_mean_squared )
{
  int i;
  double mean = 0;

  for( i=0; i<12; ++i)
  {
    mean += x[i];
  }
  mean /= 12;

  *sum_x_minus_mean_squared = 0;
  for( i=0; i<12; ++i)
  {
    x_minus_mean[i] = x[i] - mean;
    *sum_x_minus_mean_squared += (x_minus_mean[i] * x_minus_mean[i]);
  }

}


void calc_correlations( double profile_minus_mean[], double durations_minus_mean[],
                        double sum_profile_minus_mean_squared, double sum_durations_minus_mean_squared,
                        double correlations[] )
{
  int i, j;
  double numerator;
  double denominator = sqrt(sum_profile_minus_mean_squared * sum_durations_minus_mean_squared);

  for( i=0; i<12; ++i)
  {
    numerator = 0;

    for( j=0; j<12; ++j)
    {
      numerator += profile_minus_mean[j] * durations_minus_mean[ (i+j) % 12 ];
    }

   correlations[i] = numerator / denominator;

  }
}


int findkey(int durations[12])
{

                       //  0    1    2    3    4    5    6    7    8    9    10   11
                       //  do   do#  re   re#  mi   fa   fa#  so   so#  la   la#  ti
  int major_profile[12] = {635, 223, 348, 233, 438, 409, 252, 519, 239, 366, 229, 288};

  double major_profile_minus_mean[12];
  double sum_major_profile_minus_mean_squared;

                       //  0    1    2    3    4    5    6    7    8    9    10   11
                       //  la   la#  ti   do   do#  re   re#  mi   fa   fa#  so   so#
  int minor_profile[12] = {633, 268, 352, 538, 260, 353, 254, 475, 398, 269, 334, 317};

  double minor_profile_minus_mean[12];
  double sum_minor_profile_minus_mean_squared;

  double durations_minus_mean[12];
  double sum_durations_minus_mean_squared;

  double major_correlations[12];
  double minor_correlations[12];

  int i, best_key;
  double best_correlation;

  calc_minus_mean( major_profile, major_profile_minus_mean, &sum_major_profile_minus_mean_squared );
  calc_minus_mean( minor_profile, minor_profile_minus_mean, &sum_minor_profile_minus_mean_squared );
  calc_minus_mean( durations, durations_minus_mean, &sum_durations_minus_mean_squared );

  calc_correlations( major_profile_minus_mean, durations_minus_mean,
                     sum_major_profile_minus_mean_squared, sum_durations_minus_mean_squared, major_correlations );

  calc_correlations( minor_profile_minus_mean, durations_minus_mean,
                     sum_minor_profile_minus_mean_squared, sum_durations_minus_mean_squared, minor_correlations );

  best_key = 0;
  best_correlation = major_correlations[0];

  for( i=1; i<12; ++i)
  {
    if( major_correlations[i] > best_correlation )
    {
      best_correlation = major_correlations[i];
      best_key = i;
    }
  }

  for( i=0; i<12; ++i)
  {
    if( minor_correlations[i] > best_correlation )
    {
      best_correlation = minor_correlations[i];
      best_key = 12 + i;
    }
  }

  return best_key;
}

