#include <stdio.h>
#include <math.h>

int main()
{
  double goal_L, goal_R, test_L, test_R, test_distance, closest_distance, goal_amp, test_amp;
  double delta_L, delta_R;
  int org_vol, org_pan, midi_vel, midi_pan, closest_vel, closest_pan;
  unsigned char out_vel[255][13], out_pan[255][13];

  for( org_vol = 254; org_vol >= 0; --org_vol )
  {
    goal_amp = pow(10, org_vol/254.0 - 1);
    for( org_pan = 0; org_pan <= 12; ++org_pan )
    {
      goal_L = goal_amp * ( (org_pan <= 6)? 1: pow(20, 1 - 2*(org_pan/12.0) ) );
      goal_R = goal_amp * ( (org_pan >= 6)? 1: pow(20, 2*(org_pan/12.0) - 1 ) );

      closest_distance = 10;

      for( midi_vel = 127; midi_vel >= 0; --midi_vel )
      {
        test_amp = pow( midi_vel/127.0 , 1.75 );
        for( midi_pan = 1; midi_pan <= 127; ++midi_pan )
        {
          test_L = test_amp * sqrt( 2 - 2*((midi_pan-1)/126.0) );
          test_R = test_amp * sqrt(     2*((midi_pan-1)/126.0) );

          delta_L = test_L - goal_L;
          delta_R = test_R - goal_R;
          test_distance = sqrt( delta_L*delta_L + delta_R*delta_R );

          if( test_distance < closest_distance )
          {
            closest_distance = test_distance;
            closest_vel = midi_vel;
            closest_pan = midi_pan;
          }
        }
      }

      out_vel[org_vol][org_pan] = closest_vel;
      out_pan[org_vol][org_pan] = closest_pan;
    }
  }

  printf("unsigned char out_vel[255][13] = \n");

  printf("{\n");
  for( org_vol = 0; org_vol <= 254; ++org_vol)
  {
    printf("  {");
    for( org_pan = 0; org_pan <= 12; ++org_pan )
    {
      printf("%3i", out_vel[org_vol][org_pan]);
      if( org_pan < 12 ) printf(", ");
    }
    if(org_vol < 254)
      printf("},\n");
    else
      printf("}\n");
  }
  printf("};\n\n");

  printf("unsigned char out_pan[255][13] = \n");

  printf("{\n");
  for( org_vol = 0; org_vol <= 254; ++org_vol)
  {
    printf("  {");
    for( org_pan = 0; org_pan <= 12; ++org_pan )
    {
      printf("%3i", out_pan[org_vol][org_pan]);
      if( org_pan < 12 ) printf(", ");
    }
    if(org_vol < 254)
      printf("},\n");
    else
      printf("}\n");
  }
  printf("};\n\n");

}
